<?php
//CPESunatU.php //Acá se fabrica el xml para boleta, factura y notas de crédito/débito
require_once(__DIR__.'/../funcionesGlobales/validaciones.php');

//      private int ID;
//	private String FECHA_REGISTRO;
//	private int ID_EMPRESA;
//	private int ID_CLIENTE_CPE;
function cpeFactura_2_1($ruta,$cab, $det){
    $doc = new DOMDocument();
    $doc->formatOutput = FALSE;
    $doc->preserveWhiteSpace = TRUE;
    $doc->encoding = 'ISO-8859-1';

$xmlCPE = '<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?>
                <Invoice xmlns="urn:oasis:names:specification:ubl:schema:xsd:Invoice-2" xmlns:cac="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2" xmlns:cbc="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2" xmlns:ccts="urn:un:unece:uncefact:documentation:2" xmlns:ds="http://www.w3.org/2000/09/xmldsig#" xmlns:ext="urn:oasis:names:specification:ubl:schema:xsd:CommonExtensionComponents-2" xmlns:qdt="urn:oasis:names:specification:ubl:schema:xsd:QualifiedDatatypes-2" xmlns:sac="urn:sunat:names:specification:ubl:peru:schema:xsd:SunatAggregateComponents-1" xmlns:schemaLocation="urn:oasis:names:specification:ubl:schema:xsd:Invoice-2" xmlns:udt="urn:un:unece:uncefact:data:specification:UnqualifiedDataTypesSchemaModule:2" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
                <ext:UBLExtensions>
                <ext:UBLExtension>
                <ext:ExtensionContent>
                <sac:AdditionalInformation></sac:AdditionalInformation>
                </ext:ExtensionContent>
                </ext:UBLExtension>
                <ext:UBLExtension>
                <ext:ExtensionContent>
                </ext:ExtensionContent>
                </ext:UBLExtension>
                </ext:UBLExtensions>
  <cbc:UBLVersionID>2.1</cbc:UBLVersionID>
  <cbc:CustomizationID>2.0</cbc:CustomizationID>
  <cbc:ID>' .                   $cab["NRO_COMPROBANTE"].'</cbc:ID>
  <cbc:IssueDate>' .            $cab["FECHA_DOCUMENTO"].'</cbc:IssueDate>
  <cbc:IssueTime>' .            $cab["HORA_DOCUMENTO"] .  '</cbc:IssueTime>
  <cbc:DueDate>'.               $cab["FVENCE_DOCUMENTO"]. '</cbc:DueDate>';
$xmlCPE.=
  '<cbc:InvoiceTypeCode listID="0101">'.$cab["COD_TIPO_DOCUMENTO"].'</cbc:InvoiceTypeCode>';
  //'<cbc:InvoiceTypeCode listID="0101"
  //       listAgencyName="PE:SUNAT"
  //       listName="SUNAT:Identificador de Tipo de Documento"
  //       listURI="urn:pe:gob:sunat:cpe:see:gem:catalogos:catalogo01">'
  //      .$cab["COD_TIPO_DOCUMENTO"].'</cbc:InvoiceTypeCode>';
if($cab["TOTAL_LETRAS"]<>""){
$xmlCPE = $xmlCPE.
'<cbc:Note languageLocaleID="1000"><![CDATA['.$cab["TOTAL_LETRAS"].']]></cbc:Note>';
}
$xmlCPE.='
  <cbc:DocumentCurrencyCode listID="ISO 4217 Alpha"
              listName="Currency"
              listAgencyName="United Nations Economic Commission for Europe">'.$cab["COD_MONEDA"].'</cbc:DocumentCurrencyCode>
  <cbc:LineCountNumeric>'.$cab["LineCountNumeric"].'</cbc:LineCountNumeric>
  <cac:Signature>
      <cbc:ID>' .               $cab["NRO_COMPROBANTE"].'</cbc:ID>
      <cac:SignatoryParty>
          <cac:PartyIdentification>
              <cbc:ID>' .       $cab["NRO_DOCUMENTO_EMPRESA"].'</cbc:ID>
          </cac:PartyIdentification>
          <cac:PartyName>
              <cbc:Name><![CDATA['.$cab["RAZON_SOCIAL_EMPRESA"].']]></cbc:Name>
          </cac:PartyName>
      </cac:SignatoryParty>
      <cac:DigitalSignatureAttachment>
          <cac:ExternalReference>
              <cbc:URI>#'.$cab["NRO_COMPROBANTE"].'</cbc:URI>
          </cac:ExternalReference>
      </cac:DigitalSignatureAttachment>
  </cac:Signature>
  <cac:AccountingSupplierParty>
    <cac:Party>
      <cac:PartyIdentification>';
$xmlCPE.='
       <cbc:ID schemeID="'.$cab["TIPO_DOCUMENTO_EMPRESA"].'">'.$cab["NRO_DOCUMENTO_EMPRESA"].'</cbc:ID>';
        //'<cbc:ID schemeID="'.$cab["TIPO_DOCUMENTO_EMPRESA"].'"
        //        schemeName="SUNAT:Identificador de Documento de Identidad"
        //        schemeAgencyName="PE:SUNAT"
        //        schemeURI="urn:pe:gob:sunat:cpe:see:gem:catalogos:catalogo06">'.$cab["NRO_DOCUMENTO_EMPRESA"].'</cbc:ID>';
$xmlCPE.='
      </cac:PartyIdentification>
      <cac:PartyName>
        <cbc:Name><![CDATA['.$cab["NOMBRE_COMERCIAL_EMPRESA"].']]></cbc:Name>
      </cac:PartyName>
      <cac:PartyLegalEntity>
        <cbc:RegistrationName><![CDATA['.$cab["NOMBRE_COMERCIAL_EMPRESA"].']]></cbc:RegistrationName>
        <cac:RegistrationAddress>
          <cbc:ID>'.$cab["CODIGO_UBIGEO_EMPRESA"].'</cbc:ID>
          <cbc:AddressTypeCode>0000</cbc:AddressTypeCode>
        </cac:RegistrationAddress>
      </cac:PartyLegalEntity>
    </cac:Party>
  </cac:AccountingSupplierParty>
  <cac:AccountingCustomerParty>
      <cac:Party>
         <cac:PartyIdentification>
             <cbc:ID schemeID="'.$cab["TIPO_DOCUMENTO_CLIENTE"].'">'.$cab["NRO_DOCUMENTO_CLIENTE"].'</cbc:ID>
         </cac:PartyIdentification>
         <cac:PartyLegalEntity>
            <cbc:RegistrationName><![CDATA['.$cab["RAZON_SOCIAL_CLIENTE"].']]></cbc:RegistrationName>
            <cac:RegistrationAddress>
               <cac:AddressLine>
                  <cbc:Line><![CDATA['.$cab["DIRECCION_CLIENTE"].']]></cbc:Line>
               </cac:AddressLine>
               <cac:Country>
                  <cbc:IdentificationCode>'.$cab["COD_PAIS_CLIENTE"].'</cbc:IdentificationCode>
               </cac:Country>
            </cac:RegistrationAddress>
         </cac:PartyLegalEntity>
      </cac:Party>
  </cac:AccountingCustomerParty>
  <cac:TaxTotal>
      <cbc:TaxAmount currencyID="'.$cab["COD_MONEDA"].'">'.$cab["TOTAL_IGV"].'</cbc:TaxAmount>
      <cac:TaxSubtotal>
          <cbc:TaxableAmount currencyID="'.$cab["COD_MONEDA"].'">'.$cab["SUB_TOTAL"].'</cbc:TaxableAmount>
          <cbc:TaxAmount currencyID="'.$cab["COD_MONEDA"].'">'.$cab["TOTAL_IGV"].'</cbc:TaxAmount>
          <cac:TaxCategory>
              <cac:TaxScheme>
                  <cbc:ID>1000</cbc:ID>
                  <cbc:Name>IGV</cbc:Name>
                  <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
              </cac:TaxScheme>
              </cac:TaxCategory>
      </cac:TaxSubtotal>
  </cac:TaxTotal>
  <cac:LegalMonetaryTotal>
      <cbc:LineExtensionAmount currencyID="'.$cab["COD_MONEDA"].'">'.$cab["SUB_TOTAL"].'</cbc:LineExtensionAmount>
      <cbc:TaxInclusiveAmount currencyID="' .$cab["COD_MONEDA"].'">'.$cab["TOTAL"].'</cbc:TaxInclusiveAmount>
      <cbc:PayableAmount currencyID="'      .$cab["COD_MONEDA"].'">'.$cab["TOTAL"].'</cbc:PayableAmount>
  </cac:LegalMonetaryTotal>';
//Insertado 29.03.2021 por mensaje de OSE; sirve p sunat <cbc:TaxInclusiveAmount currencyID="' .$cab["COD_MONEDA"].'">'.$cab["TOTAL"].'</cbc:TaxInclusiveAmount>

          //<cbc:TaxAmount currencyID="'.$cab["COD_MONEDA"].'">'
          //                            .($det[$i]["txtCANTIDAD_DET"]*$det[$i]["txtPRECIO_DET"]-$det[$i]["txtIMPORTE_DET"])
          //                            .'</cbc:TaxAmount>
          //<cac:TaxSubtotal>
          //    <cbc:TaxableAmount currencyID="'.$cab["COD_MONEDA"].'">'.$det[$i]["txtIMPORTE_DET"].'</cbc:TaxableAmount>
          //    <cbc:TaxAmount currencyID="'.$cab["COD_MONEDA"].'">'
          //                                .($det[$i]["txtCANTIDAD_DET"]*$det[$i]["txtPRECIO_DET"]-$det[$i]["txtIMPORTE_DET"])
          //                                .'</cbc:TaxAmount>

for ($i = 0; $i < count($det); $i++) {
    $xmlCPE = $xmlCPE . '
    <cac:InvoiceLine>
      <cbc:ID>'.$det[$i]["txtITEM"].'</cbc:ID>
      <cbc:InvoicedQuantity unitCode="'.$det[$i]["txtUNIDAD_MEDIDA_DET"].'">'.$det[$i]["txtCANTIDAD_DET"].'</cbc:InvoicedQuantity>
      <cbc:LineExtensionAmount currencyID="'.$cab["COD_MONEDA"].'">'.$det[$i]["txtIMPORTE_DET"].'</cbc:LineExtensionAmount>
      <cac:PricingReference>
          <cac:AlternativeConditionPrice>
              <cbc:PriceAmount currencyID="'.$cab["COD_MONEDA"].'">'.round($det[$i]["txtPRECIO_DET"]
                                                                           *(1.0+$cab["P100IGV"]/100.0)
                                                                        ,2).
              '</cbc:PriceAmount>
              <cbc:PriceTypeCode>'.$det[$i]["txtPRECIO_TIPO_CODIGO"].'</cbc:PriceTypeCode>
          </cac:AlternativeConditionPrice>
      </cac:PricingReference>
      <cac:TaxTotal>
          <cbc:TaxAmount currencyID="'.$cab["COD_MONEDA"].'">'
                                      .($det[$i]["txtIGV"])
                                      .'</cbc:TaxAmount>
          <cac:TaxSubtotal>
              <cbc:TaxableAmount currencyID="'.$cab["COD_MONEDA"].'">'.$det[$i]["txtIMPORTE_DET"].'</cbc:TaxableAmount>
              <cbc:TaxAmount currencyID="'.$cab["COD_MONEDA"].'">'
                                          .($det[$i]["txtIGV"])
                                          .'</cbc:TaxAmount>
              <cac:TaxCategory>
                  <cbc:Percent>'.$cab["P100IGV"].'</cbc:Percent>
                  <cbc:TaxExemptionReasonCode>'.$det[$i]["txtCOD_TIPO_OPERACION"].'</cbc:TaxExemptionReasonCode>
                  <cac:TaxScheme>
                      <cbc:ID>1000</cbc:ID>
                      <cbc:Name>IGV</cbc:Name>
                      <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
                  </cac:TaxScheme>
              </cac:TaxCategory>
          </cac:TaxSubtotal>
      </cac:TaxTotal>
      <cac:Item>
          <cbc:Description><![CDATA['.ValidarCaracteresInv((isset($det[$i]["txtDESCRIPCION_DET"]))?$det[$i]["txtDESCRIPCION_DET"]:"").']]></cbc:Description>
          <cac:SellersItemIdentification>
              <cbc:ID><![CDATA['.ValidarCaracteresInv((isset($det[$i]["txtCODIGO_DET"]))?$det[$i]["txtCODIGO_DET"]:"").']]></cbc:ID>
          </cac:SellersItemIdentification>
      </cac:Item>
      <cac:Price>
          <cbc:PriceAmount currencyID="'.$cab["COD_MONEDA"].'">'.round($det[$i]["txtIMPORTE_DET"]/$det[$i]["txtCANTIDAD_DET"],2).'</cbc:PriceAmount>
      </cac:Price>
  </cac:InvoiceLine>';
}

$xmlCPE = $xmlCPE . '
</Invoice>';

file_put_contents(dirname(__FILE__,200)."dat(U).txt", $ruta . '.XML');
file_put_contents($ruta.'(sinFirma).XML',$xmlCPE);

$doc->loadXML($xmlCPE); //Acá se incrusta la firma digital

//oldU $doc->save(dirname(__FILE__) . '/' . $ruta . '.XML');
$doc->save($ruta . '.XML');
return 'XML CREADO';
//dfgdfgdfgdf
//fin function cpeFactura($ruta,$cab, $det)
}

function cpeFactura_2_0($ruta,$cabecera, $detalle){
    $doc = new DOMDocument();
    $doc->formatOutput = FALSE;
    $doc->preserveWhiteSpace = TRUE;
    $doc->encoding = 'ISO-8859-1';


    $xmlCPE = '<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?>
                <Invoice xmlns="urn:oasis:names:specification:ubl:schema:xsd:Invoice-2" xmlns:cac="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2" xmlns:cbc="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2" xmlns:ccts="urn:un:unece:uncefact:documentation:2" xmlns:ds="http://www.w3.org/2000/09/xmldsig#" xmlns:ext="urn:oasis:names:specification:ubl:schema:xsd:CommonExtensionComponents-2" xmlns:qdt="urn:oasis:names:specification:ubl:schema:xsd:QualifiedDatatypes-2" xmlns:sac="urn:sunat:names:specification:ubl:peru:schema:xsd:SunatAggregateComponents-1" xmlns:schemaLocation="urn:oasis:names:specification:ubl:schema:xsd:Invoice-2" xmlns:udt="urn:un:unece:uncefact:data:specification:UnqualifiedDataTypesSchemaModule:2" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
                <ext:UBLExtensions>
                <ext:UBLExtension>
                <ext:ExtensionContent>
                <sac:AdditionalInformation>
                    <sac:AdditionalMonetaryTotal>
                        <cbc:ID>1001</cbc:ID>
                        <cbc:PayableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_GRAVADAS"] . '</cbc:PayableAmount>
                    </sac:AdditionalMonetaryTotal>
                    <sac:AdditionalMonetaryTotal>
                        <cbc:ID>1002</cbc:ID>
                        <cbc:PayableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_INAFECTA"] . '</cbc:PayableAmount>
                    </sac:AdditionalMonetaryTotal>
                    <sac:AdditionalMonetaryTotal>
                        <cbc:ID>1003</cbc:ID>
                        <cbc:PayableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_EXONERADAS"] . '</cbc:PayableAmount>
                    </sac:AdditionalMonetaryTotal>
                    <sac:AdditionalMonetaryTotal>
                        <cbc:ID>1004</cbc:ID>
                        <cbc:PayableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_GRATUITAS"] . '</cbc:PayableAmount>
                    </sac:AdditionalMonetaryTotal>';
                    if($cabecera["TOTAL_LETRAS"]<>""){
                    $xmlCPE = $xmlCPE .
                    '<sac:AdditionalProperty>
                        <cbc:ID>1000</cbc:ID>
                        <cbc:Value>' . $cabecera["TOTAL_LETRAS"] . '</cbc:Value>
                    </sac:AdditionalProperty>';
                   }
                   if($cabecera["TOTAL_GRATUITAS"]>0){
                    $xmlCPE = $xmlCPE .
                    '<sac:AdditionalProperty>
                        <cbc:ID>1002</cbc:ID>
                        <cbc:Value>TRANSFERENCIA GRATUITA DE UN BIEN Y/O SERVICIO PRESTADO GRATUITAMENTE</cbc:Value>
                    </sac:AdditionalProperty>';
                   }
$xmlCPE = $xmlCPE
              .'</sac:AdditionalInformation>
                </ext:ExtensionContent>
                </ext:UBLExtension>
                <ext:UBLExtension>
                <ext:ExtensionContent>
                </ext:ExtensionContent>
                </ext:UBLExtension>
                </ext:UBLExtensions>
                <cbc:UBLVersionID>2.0</cbc:UBLVersionID>
                <cbc:CustomizationID>1.0</cbc:CustomizationID>
                <cbc:ID>' .                   $cabecera["NRO_COMPROBANTE"] . '</cbc:ID>
                <cbc:IssueDate>' .            $cabecera["FECHA_DOCUMENTO"] . '</cbc:IssueDate>
                <cbc:InvoiceTypeCode>' .      $cabecera["COD_TIPO_DOCUMENTO"] . '</cbc:InvoiceTypeCode>
                <cbc:DocumentCurrencyCode>' . $cabecera["COD_MONEDA"] . '</cbc:DocumentCurrencyCode>
                <cac:Signature>
                    <cbc:ID>' .               $cabecera["NRO_COMPROBANTE"] . '</cbc:ID>
                    <cac:SignatoryParty>
                        <cac:PartyIdentification>
                            <cbc:ID>' .       $cabecera["NRO_DOCUMENTO_EMPRESA"] . '</cbc:ID>
                        </cac:PartyIdentification>
                        <cac:PartyName>
                            <cbc:Name><![CDATA[' . $cabecera["RAZON_SOCIAL_EMPRESA"] . ']]></cbc:Name>
                        </cac:PartyName>
                    </cac:SignatoryParty>
                    <cac:DigitalSignatureAttachment>
                        <cac:ExternalReference>
                            <cbc:URI>#' . $cabecera["NRO_COMPROBANTE"] . '</cbc:URI>
                        </cac:ExternalReference>
                    </cac:DigitalSignatureAttachment>
                </cac:Signature>
                <cac:AccountingSupplierParty>
                    <cbc:CustomerAssignedAccountID>' . $cabecera["NRO_DOCUMENTO_EMPRESA"] . '</cbc:CustomerAssignedAccountID>
                    <cbc:AdditionalAccountID>' .       $cabecera["TIPO_DOCUMENTO_EMPRESA"] . '</cbc:AdditionalAccountID>
                    <cac:Party>
                        <cac:PartyName>
                            <cbc:Name><![CDATA[' .     $cabecera["NOMBRE_COMERCIAL_EMPRESA"] . ']]></cbc:Name>
                        </cac:PartyName>
                        <cac:PostalAddress>
                            <cbc:ID>' . $cabecera["CODIGO_UBIGEO_EMPRESA"] . '</cbc:ID>
                            <cbc:StreetName><![CDATA[' . $cabecera["DIRECCION_EMPRESA"] . ']]></cbc:StreetName>
                            <cbc:CitySubdivisionName/>
                            <cbc:CityName><![CDATA[' . $cabecera["DEPARTAMENTO_EMPRESA"] . ']]></cbc:CityName>
                            <cbc:CountrySubentity><![CDATA[' . $cabecera["PROVINCIA_EMPRESA"] . ']]></cbc:CountrySubentity>
                            <cbc:District><![CDATA[' . $cabecera["DISTRITO_EMPRESA"] . ']]></cbc:District>
                            <cac:Country>
                                <cbc:IdentificationCode>' . $cabecera["CODIGO_PAIS_EMPRESA"] . '</cbc:IdentificationCode>
                            </cac:Country>
                        </cac:PostalAddress>
                        <cac:PartyLegalEntity>
                        <cbc:RegistrationName><![CDATA[' . $cabecera["RAZON_SOCIAL_EMPRESA"] . ']]></cbc:RegistrationName>
                        </cac:PartyLegalEntity>
                    </cac:Party>
                </cac:AccountingSupplierParty>
                <cac:AccountingCustomerParty>
                    <cbc:CustomerAssignedAccountID>' . $cabecera["NRO_DOCUMENTO_CLIENTE"] . '</cbc:CustomerAssignedAccountID>
                    <cbc:AdditionalAccountID>' . $cabecera["TIPO_DOCUMENTO_CLIENTE"] . '</cbc:AdditionalAccountID>
                    <cac:Party>
                        <cac:PhysicalLocation>
                            <cbc:Description><![CDATA[' . $cabecera["DIRECCION_CLIENTE"] . ']]></cbc:Description>
                        </cac:PhysicalLocation>
                        <cac:PartyLegalEntity>
                            <cbc:RegistrationName><![CDATA[' . $cabecera["RAZON_SOCIAL_CLIENTE"] . ']]></cbc:RegistrationName>
                            <cac:RegistrationAddress>
                                <cbc:StreetName><![CDATA[' . $cabecera["CIUDAD_CLIENTE"] . ']]></cbc:StreetName>
                                <cac:Country>
                                    <cbc:IdentificationCode>' . $cabecera["COD_PAIS_CLIENTE"] . '</cbc:IdentificationCode>
                                </cac:Country>
                            </cac:RegistrationAddress>
                        </cac:PartyLegalEntity>
                    </cac:Party>
                </cac:AccountingCustomerParty>
                <cac:TaxTotal>
                    <cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_IGV"] . '</cbc:TaxAmount>
                    <cac:TaxSubtotal>
                        <cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_IGV"] . '</cbc:TaxAmount>
                        <cac:TaxCategory>
                            <cac:TaxScheme>
                                <cbc:ID>1000</cbc:ID>
                                <cbc:Name>IGV</cbc:Name>
                                <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
                            </cac:TaxScheme>
                            </cac:TaxCategory>
                    </cac:TaxSubtotal>
                </cac:TaxTotal>
                <cac:LegalMonetaryTotal>
                    <cbc:LineExtensionAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["SUB_TOTAL"] . '</cbc:LineExtensionAmount>
                    <cbc:TaxExclusiveAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_IGV"] . '</cbc:TaxExclusiveAmount>
                    <cbc:PayableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL"] . '</cbc:PayableAmount>
                </cac:LegalMonetaryTotal>';

    for ($i = 0; $i < count($detalle); $i++) {
        $xmlCPE = $xmlCPE . '<cac:InvoiceLine>
                                <cbc:ID>' . $detalle[$i]["txtITEM"] . '</cbc:ID>
                                <cbc:InvoicedQuantity unitCode="' . $detalle[$i]["txtUNIDAD_MEDIDA_DET"] . '">' . $detalle[$i]["txtCANTIDAD_DET"] . '</cbc:InvoicedQuantity>
                                <cbc:LineExtensionAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIMPORTE_DET"] . '</cbc:LineExtensionAmount>
                                <cac:PricingReference>
                                    <cac:AlternativeConditionPrice>
                                        <cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
                                        <cbc:PriceTypeCode>' . $detalle[$i]["txtPRECIO_TIPO_CODIGO"] . '</cbc:PriceTypeCode>
                                    </cac:AlternativeConditionPrice>
                                </cac:PricingReference>
                                <cac:TaxTotal>
                                    <cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIGV"] . '</cbc:TaxAmount>
                                    <cac:TaxSubtotal>
                                        <cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIGV"] . '</cbc:TaxAmount>
                                        <cac:TaxCategory>
                                            <cbc:TaxExemptionReasonCode>' . $detalle[$i]["txtCOD_TIPO_OPERACION"] . '</cbc:TaxExemptionReasonCode>
                                            <cac:TaxScheme>
                                                <cbc:ID>1000</cbc:ID>
                                                <cbc:Name>IGV</cbc:Name>
                                                <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
                                            </cac:TaxScheme>
                                        </cac:TaxCategory>
                                    </cac:TaxSubtotal>
                                </cac:TaxTotal>
                                <cac:Item>
                                    <cbc:Description><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtDESCRIPCION_DET"]))?$detalle[$i]["txtDESCRIPCION_DET"]:"") . ']]></cbc:Description>
                                    <cac:SellersItemIdentification>
                                        <cbc:ID><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtCODIGO_DET"]))?$detalle[$i]["txtCODIGO_DET"]:"") . ']]></cbc:ID>
                                    </cac:SellersItemIdentification>
                                </cac:Item>
                                <cac:Price>
                                    <cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
                                </cac:Price>
                            </cac:InvoiceLine>';
    }

    $xmlCPE = $xmlCPE . '</Invoice>';

    file_put_contents(dirname(__FILE__,200)."dat(U).txt", $ruta . '.XML');
    $doc->loadXML($xmlCPE);
    //oldU $doc->save(dirname(__FILE__) . '/' . $ruta . '.XML');
    $doc->save($ruta . '.XML');
    return 'XML CREADO';
    //dfgdfgdfgdf
    //fin function cpeFactura($ruta,$cabecera, $detalle)
}

function cpeNC_2_0($ruta, $cabecera, $detalle) {
    $doc = new DOMDocument();
    $doc->formatOutput = FALSE;
    $doc->preserveWhiteSpace = TRUE;
    $doc->encoding = 'ISO-8859-1';
    $xmlCPE = '<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?><CreditNote xmlns="urn:oasis:names:specification:ubl:schema:xsd:CreditNote-2" xmlns:cac="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2" xmlns:cbc="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2" xmlns:ccts="urn:un:unece:uncefact:documentation:2" xmlns:ds="http://www.w3.org/2000/09/xmldsig#" xmlns:ext="urn:oasis:names:specification:ubl:schema:xsd:CommonExtensionComponents-2" xmlns:qdt="urn:oasis:names:specification:ubl:schema:xsd:QualifiedDatatypes-2" xmlns:sac="urn:sunat:names:specification:ubl:peru:schema:xsd:SunatAggregateComponents-1" xmlns:udt="urn:un:unece:uncefact:data:specification:UnqualifiedDataTypesSchemaModule:2" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<ext:UBLExtensions>
<ext:UBLExtension>
<ext:ExtensionContent>
    <sac:AdditionalInformation>
        <sac:AdditionalMonetaryTotal>
            <cbc:ID>1001</cbc:ID>
            <cbc:PayableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_GRAVADAS"] . '</cbc:PayableAmount>
        </sac:AdditionalMonetaryTotal>
    </sac:AdditionalInformation>
</ext:ExtensionContent>
</ext:UBLExtension>
<ext:UBLExtension>
<ext:ExtensionContent>
</ext:ExtensionContent>
</ext:UBLExtension>
</ext:UBLExtensions>
<cbc:UBLVersionID>2.0</cbc:UBLVersionID>
<cbc:CustomizationID>1.0</cbc:CustomizationID>
<cbc:ID>' . $cabecera["NRO_COMPROBANTE"] . '</cbc:ID>
<cbc:IssueDate>' . $cabecera["FECHA_DOCUMENTO"] . '</cbc:IssueDate>
<cbc:DocumentCurrencyCode>' . $cabecera["COD_MONEDA"] . '</cbc:DocumentCurrencyCode>
<cac:DiscrepancyResponse>
    <cbc:ReferenceID>' . $cabecera["NRO_DOCUMENTO_MODIFICA"] . '</cbc:ReferenceID>
    <cbc:ResponseCode>' . $cabecera["COD_TIPO_MOTIVO"] . '</cbc:ResponseCode>
    <cbc:Description><![CDATA[' . $cabecera["DESCRIPCION_MOTIVO"] . ']]></cbc:Description>
</cac:DiscrepancyResponse>
<cac:BillingReference>
    <cac:InvoiceDocumentReference>
        <cbc:ID>' . $cabecera["NRO_DOCUMENTO_MODIFICA"] . '</cbc:ID>
        <cbc:DocumentTypeCode>' . $cabecera["TIPO_COMPROBANTE_MODIFICA"] . '</cbc:DocumentTypeCode>
    </cac:InvoiceDocumentReference>
</cac:BillingReference>
<cac:Signature>
    <cbc:ID>' . $cabecera["NRO_COMPROBANTE"] . '</cbc:ID>
    <cac:SignatoryParty>
        <cac:PartyIdentification>
            <cbc:ID>' . $cabecera["NRO_DOCUMENTO_EMPRESA"] . '</cbc:ID>
        </cac:PartyIdentification>
        <cac:PartyName>
            <cbc:Name><![CDATA[' . $cabecera["RAZON_SOCIAL_EMPRESA"] . ']]></cbc:Name>
        </cac:PartyName>
    </cac:SignatoryParty>
    <cac:DigitalSignatureAttachment>
        <cac:ExternalReference>
            <cbc:URI>#' . $cabecera["NRO_COMPROBANTE"] . '</cbc:URI>
        </cac:ExternalReference>
    </cac:DigitalSignatureAttachment>
</cac:Signature>
<cac:AccountingSupplierParty>
    <cbc:CustomerAssignedAccountID>' . $cabecera["NRO_DOCUMENTO_EMPRESA"] . '</cbc:CustomerAssignedAccountID>
    <cbc:AdditionalAccountID>' . $cabecera["TIPO_DOCUMENTO_EMPRESA"] . '</cbc:AdditionalAccountID>
    <cac:Party>
        <cac:PartyName>
            <cbc:Name><![CDATA[' . $cabecera["NOMBRE_COMERCIAL_EMPRESA"] . ']]></cbc:Name>
        </cac:PartyName>
        <cac:PostalAddress>
            <cbc:ID>' . $cabecera["CODIGO_UBIGEO_EMPRESA"] . '</cbc:ID>
            <cbc:StreetName><![CDATA[' . $cabecera["DIRECCION_EMPRESA"] . ']]></cbc:StreetName>
            <cbc:CitySubdivisionName/>
            <cbc:CityName><![CDATA[' . $cabecera["DEPARTAMENTO_EMPRESA"] . ']]></cbc:CityName>
            <cbc:CountrySubentity><![CDATA[' . $cabecera["PROVINCIA_EMPRESA"] . ']]></cbc:CountrySubentity>
            <cbc:District><![CDATA[' . $cabecera["DISTRITO_EMPRESA"] . ']]></cbc:District>
            <cac:Country>
                <cbc:IdentificationCode>' . $cabecera["CODIGO_PAIS_EMPRESA"] . '</cbc:IdentificationCode>
            </cac:Country>
        </cac:PostalAddress>
        <cac:PartyLegalEntity>
            <cbc:RegistrationName><![CDATA[' . $cabecera["RAZON_SOCIAL_EMPRESA"] . ']]></cbc:RegistrationName>
        </cac:PartyLegalEntity>
    </cac:Party>
</cac:AccountingSupplierParty>
<cac:AccountingCustomerParty>
    <cbc:CustomerAssignedAccountID>' . $cabecera["NRO_DOCUMENTO_CLIENTE"] . '</cbc:CustomerAssignedAccountID>
    <cbc:AdditionalAccountID>' . $cabecera["TIPO_DOCUMENTO_CLIENTE"] . '</cbc:AdditionalAccountID>
    <cac:Party>
        <cac:PhysicalLocation>
            <cbc:Description><![CDATA[' . $cabecera["DIRECCION_CLIENTE"] . ']]></cbc:Description>
        </cac:PhysicalLocation>
        <cac:PartyLegalEntity>
            <cbc:RegistrationName><![CDATA[' . $cabecera["RAZON_SOCIAL_CLIENTE"] . ']]></cbc:RegistrationName>
            <cac:RegistrationAddress>
                <cbc:StreetName><![CDATA[' . $cabecera["CIUDAD_CLIENTE"] . ']]></cbc:StreetName>
                <cac:Country>
                    <cbc:IdentificationCode>' . $cabecera["COD_PAIS_CLIENTE"] . '</cbc:IdentificationCode>
                </cac:Country>
            </cac:RegistrationAddress>
        </cac:PartyLegalEntity>
    </cac:Party>
</cac:AccountingCustomerParty>
<cac:TaxTotal>
    <cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_IGV"] . '</cbc:TaxAmount>
    <cac:TaxSubtotal>
        <cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_IGV"] . '</cbc:TaxAmount>
        <cac:TaxCategory>
            <cac:TaxScheme>
                <cbc:ID>1000</cbc:ID>
                <cbc:Name>IGV</cbc:Name>
                <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
            </cac:TaxScheme>
        </cac:TaxCategory>
    </cac:TaxSubtotal>
</cac:TaxTotal>
<cac:LegalMonetaryTotal>
    <cbc:PayableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL"] . '</cbc:PayableAmount>
</cac:LegalMonetaryTotal>';

    for ($i = 0; $i < count($detalle); $i++) {
        $xmlCPE = $xmlCPE . '<cac:CreditNoteLine>
                                <cbc:ID>' . $detalle[$i]["txtITEM"] . '</cbc:ID>
                                <cbc:CreditedQuantity unitCode="' . $detalle[$i]["txtUNIDAD_MEDIDA_DET"] . '">' . $detalle[$i]["txtCANTIDAD_DET"] . '</cbc:CreditedQuantity>
                                <cbc:LineExtensionAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIMPORTE_DET"] . '</cbc:LineExtensionAmount>
                                <cac:PricingReference>
                                    <cac:AlternativeConditionPrice>
                                        <cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
                                        <cbc:PriceTypeCode>' . $detalle[$i]["txtPRECIO_TIPO_CODIGO"] . '</cbc:PriceTypeCode>
                                    </cac:AlternativeConditionPrice>
                                </cac:PricingReference>
                                <cac:TaxTotal>
                                    <cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIGV"] . '</cbc:TaxAmount>
                                    <cac:TaxSubtotal>
                                    <cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIGV"] . '</cbc:TaxAmount>
                                    <cac:TaxCategory>
                                        <cbc:TaxExemptionReasonCode>' . $detalle[$i]["txtCOD_TIPO_OPERACION"] . '</cbc:TaxExemptionReasonCode>
                                        <cac:TaxScheme>
                                            <cbc:ID>1000</cbc:ID>
                                            <cbc:Name>IGV</cbc:Name>
                                            <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
                                        </cac:TaxScheme>
                                    </cac:TaxCategory>
                                    </cac:TaxSubtotal>
                                </cac:TaxTotal>
                                <cac:Item>
                                    <cbc:Description><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtDESCRIPCION_DET"]))?$detalle[$i]["txtDESCRIPCION_DET"]:"") . ']]></cbc:Description>
                                    <cac:SellersItemIdentification>
                                        <cbc:ID><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtCODIGO_DET"]))?$detalle[$i]["txtCODIGO_DET"]:"") . ']]></cbc:ID>
                                    </cac:SellersItemIdentification>
                                </cac:Item>
                                <cac:Price>
                                    <cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
                                </cac:Price>
                                </cac:CreditNoteLine>';
    }

    $xmlCPE = $xmlCPE . '</CreditNote>';

    file_put_contents(dirname(__FILE__,200)."datNC.txt", $ruta . '.XML');
    $doc->loadXML($xmlCPE);

    //apoloFunca $doc->save(dirname(__FILE__) . '/' . $ruta . '.XML');
    $doc->save($ruta . '.XML');
    return 'XML CREADO';
}

function cpeNC_2_1($ruta, $cabecera, $detalle) {
    //Vino del 2.1
    //$doc = new DOMDocument();
    //$doc->formatOutput = FALSE;
    //$doc->preserveWhiteSpace = TRUE;
    //$doc->encoding = 'utf-8';

    $doc = new DOMDocument();
    $doc->formatOutput = FALSE;
    $doc->preserveWhiteSpace = TRUE;
    $doc->encoding = 'ISO-8859-1';

    //$doc->encoding = 'ISO-8859-1';
    //$doc->encoding = 'utf-8';

    //Se cambió el encabezado de Jose <ext:UBLExtensions>...</ext:UBLExtensions> incluido tag delimitador
    $xmlCPE = '<?xml version="1.0" encoding="UTF-8"?>
<CreditNote xmlns="urn:oasis:names:specification:ubl:schema:xsd:CreditNote-2" xmlns:cac="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2" xmlns:cbc="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2" xmlns:ccts="urn:un:unece:uncefact:documentation:2" xmlns:ds="http://www.w3.org/2000/09/xmldsig#" xmlns:ext="urn:oasis:names:specification:ubl:schema:xsd:CommonExtensionComponents-2" xmlns:qdt="urn:oasis:names:specification:ubl:schema:xsd:QualifiedDatatypes-2" xmlns:sac="urn:sunat:names:specification:ubl:peru:schema:xsd:SunatAggregateComponents-1" xmlns:udt="urn:un:unece:uncefact:data:specification:UnqualifiedDataTypesSchemaModule:2" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
    <ext:UBLExtensions>
      <ext:UBLExtension>
      <ext:ExtensionContent>
      <sac:AdditionalInformation></sac:AdditionalInformation>
      </ext:ExtensionContent>
      </ext:UBLExtension>
      <ext:UBLExtension>
      <ext:ExtensionContent>
      </ext:ExtensionContent>
      </ext:UBLExtension>
    </ext:UBLExtensions>
    <cbc:UBLVersionID>2.1</cbc:UBLVersionID>
    <cbc:CustomizationID>2.0</cbc:CustomizationID>
    <cbc:ID>' . $cabecera["NRO_COMPROBANTE"] . '</cbc:ID>
    <cbc:IssueDate>' . $cabecera["FECHA_DOCUMENTO"] . '</cbc:IssueDate>
    <cbc:IssueTime>00:00:00</cbc:IssueTime>
    <cbc:DocumentCurrencyCode>' . $cabecera["COD_MONEDA"] . '</cbc:DocumentCurrencyCode>
    <cac:DiscrepancyResponse>
        <cbc:ReferenceID>' . $cabecera["NRO_DOCUMENTO_MODIFICA"] . '</cbc:ReferenceID>
        <cbc:ResponseCode>' . $cabecera["COD_TIPO_MOTIVO"] . '</cbc:ResponseCode>
        <cbc:Description><![CDATA[' . $cabecera["DESCRIPCION_MOTIVO"] . ']]></cbc:Description>
    </cac:DiscrepancyResponse>
    <cac:BillingReference>
        <cac:InvoiceDocumentReference>
            <cbc:ID>' . $cabecera["NRO_DOCUMENTO_MODIFICA"] . '</cbc:ID>
            <cbc:DocumentTypeCode>' . $cabecera["TIPO_COMPROBANTE_MODIFICA"] . '</cbc:DocumentTypeCode>
        </cac:InvoiceDocumentReference>
    </cac:BillingReference>
    <cac:Signature>
        <cbc:ID>IDSignST</cbc:ID>
        <cac:SignatoryParty>
            <cac:PartyIdentification>
                <cbc:ID>' . $cabecera["NRO_DOCUMENTO_EMPRESA"] . '</cbc:ID>
            </cac:PartyIdentification>
            <cac:PartyName>
                <cbc:Name><![CDATA[' . $cabecera["RAZON_SOCIAL_EMPRESA"] . ']]></cbc:Name>
            </cac:PartyName>
        </cac:SignatoryParty>
        <cac:DigitalSignatureAttachment>
            <cac:ExternalReference>
                <cbc:URI>#SignatureSP</cbc:URI>
            </cac:ExternalReference>
        </cac:DigitalSignatureAttachment>
    </cac:Signature>
    <cac:AccountingSupplierParty>
        <cac:Party>
            <cac:PartyIdentification>
                <cbc:ID schemeID="' . $cabecera["TIPO_DOCUMENTO_EMPRESA"] . '" schemeName="SUNAT:Identificador de Documento de Identidad" schemeAgencyName="PE:SUNAT" schemeURI="urn:pe:gob:sunat:cpe:see:gem:catalogos:catalogo06">' . $cabecera["NRO_DOCUMENTO_EMPRESA"] . '</cbc:ID>
            </cac:PartyIdentification>
            <cac:PartyName>
                <cbc:Name><![CDATA[' . $cabecera["NOMBRE_COMERCIAL_EMPRESA"] . ']]></cbc:Name>
            </cac:PartyName>
            <cac:PartyLegalEntity>
<cbc:RegistrationName><![CDATA[' . $cabecera["RAZON_SOCIAL_EMPRESA"] . ']]></cbc:RegistrationName>
                <cac:RegistrationAddress>
                    <cbc:AddressTypeCode>0001</cbc:AddressTypeCode>
                </cac:RegistrationAddress>
            </cac:PartyLegalEntity>
        </cac:Party>
    </cac:AccountingSupplierParty>
    <cac:AccountingCustomerParty>
        <cac:Party>
            <cac:PartyIdentification>
                <cbc:ID schemeID="' . $cabecera["TIPO_DOCUMENTO_CLIENTE"] . '" schemeName="SUNAT:Identificador de Documento de Identidad" schemeAgencyName="PE:SUNAT" schemeURI="urn:pe:gob:sunat:cpe:see:gem:catalogos:catalogo06">' . $cabecera["NRO_DOCUMENTO_CLIENTE"] . '</cbc:ID>
            </cac:PartyIdentification>
            <cac:PartyLegalEntity>
<cbc:RegistrationName><![CDATA[' . $cabecera["RAZON_SOCIAL_CLIENTE"] . ']]></cbc:RegistrationName>
            </cac:PartyLegalEntity>
        </cac:Party>
    </cac:AccountingCustomerParty>';

        if ($cabecera["TOTAL_DESCUENTO"] > 0) {//En nota de crédito de llama.pe, no existe TOTAL_DESCUENTO
               $xmlCPE = $xmlCPE .
                       '<cac:AllowanceCharge>
                       <cbc:ChargeIndicator>false</cbc:ChargeIndicator>
                       <cbc:AllowanceChargeReasonCode listName="Cargo/descuento" listAgencyName="PE:SUNAT" listURI="urn:pe:gob:sunat:cpe:see:gem:catalogos:catalogo53">00</cbc:AllowanceChargeReasonCode>
                       <cbc:Amount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_DESCUENTO"] . '</cbc:Amount>
                       </cac:AllowanceCharge>';
        }

	$xmlCPE = $xmlCPE .
                '<cac:TaxTotal>
        <cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_IGV"] . '</cbc:TaxAmount>
        <cac:TaxSubtotal>
<cbc:TaxableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_GRAVADAS"] . '</cbc:TaxableAmount>
<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_IGV"] . '</cbc:TaxAmount>
            <cac:TaxCategory>
                <cac:TaxScheme>
                    <cbc:ID schemeID="UN/ECE 5153" schemeAgencyID="6">1000</cbc:ID>
                    <cbc:Name>IGV</cbc:Name>
                    <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
                </cac:TaxScheme>
            </cac:TaxCategory>
        </cac:TaxSubtotal>';
        if ($cabecera["TOTAL_ISC"] > 0) {
            $xmlCPE = $xmlCPE .
                    '<cac:TaxSubtotal>
			<cbc:TaxableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_ISC"] . '</cbc:TaxableAmount>
			<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_ISC"] . '</cbc:TaxAmount>
			<cac:TaxCategory>
				<cbc:ID schemeID="UN/ECE 5305" schemeName="Tax Category Identifier" schemeAgencyName="United Nations Economic Commission for Europe">S</cbc:ID>
				<cac:TaxScheme>
					<cbc:ID schemeID="UN/ECE 5153" schemeAgencyID="6">2000</cbc:ID>
					<cbc:Name>ISC</cbc:Name>
					<cbc:TaxTypeCode>EXC</cbc:TaxTypeCode>
				</cac:TaxScheme>
			</cac:TaxCategory>
		</cac:TaxSubtotal>';
        }
        //CAMPO NUEVO
        if ($cabecera["TOTAL_EXPORTACION"] > 0) {
            $xmlCPE = $xmlCPE .
                    '<cac:TaxSubtotal>
			<cbc:TaxableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_EXPORTACION"] . '</cbc:TaxableAmount>
			<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">0.00</cbc:TaxAmount>
			<cac:TaxCategory>
				<cbc:ID schemeID="UN/ECE 5305" schemeName="Tax Category Identifier" schemeAgencyName="United Nations Economic Commission for Europe">G</cbc:ID>
				<cac:TaxScheme>
					<cbc:ID schemeID="UN/ECE 5153" schemeAgencyID="6">9995</cbc:ID>
					<cbc:Name>EXP</cbc:Name>
					<cbc:TaxTypeCode>FRE</cbc:TaxTypeCode>
				</cac:TaxScheme>
			</cac:TaxCategory>
		</cac:TaxSubtotal>';
        }
        if ($cabecera["TOTAL_GRATUITAS"] > 0) {
            $xmlCPE = $xmlCPE .
                    '<cac:TaxSubtotal>
			<cbc:TaxableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_GRATUITAS"] . '</cbc:TaxableAmount>
			<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">0.00</cbc:TaxAmount>
			<cac:TaxCategory>
				<cbc:ID schemeID="UN/ECE 5305" schemeName="Tax Category Identifier" schemeAgencyName="United Nations Economic Commission for Europe">Z</cbc:ID>
				<cac:TaxScheme>
					<cbc:ID schemeID="UN/ECE 5153" schemeAgencyID="6">9996</cbc:ID>
					<cbc:Name>GRA</cbc:Name>
					<cbc:TaxTypeCode>FRE</cbc:TaxTypeCode>
				</cac:TaxScheme>
			</cac:TaxCategory>
		</cac:TaxSubtotal>';
        }
        if ($cabecera["TOTAL_EXONERADAS"] > 0) {
            $xmlCPE = $xmlCPE .
                    '<cac:TaxSubtotal>
			<cbc:TaxableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_EXONERADAS"] . '</cbc:TaxableAmount>
			<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">0.00</cbc:TaxAmount>
			<cac:TaxCategory>
				<cbc:ID schemeID="UN/ECE 5305" schemeName="Tax Category Identifier" schemeAgencyName="United Nations Economic Commission for Europe">E</cbc:ID>
				<cac:TaxScheme>
					<cbc:ID schemeID="UN/ECE 5153" schemeAgencyID="6">9997</cbc:ID>
					<cbc:Name>EXO</cbc:Name>
					<cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
				</cac:TaxScheme>
			</cac:TaxCategory>
		</cac:TaxSubtotal>';
        }
        if ($cabecera["TOTAL_INAFECTA"] > 0) {
            $xmlCPE = $xmlCPE .
                    '<cac:TaxSubtotal>
			<cbc:TaxableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_INAFECTA"] . '</cbc:TaxableAmount>
			<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">0.00</cbc:TaxAmount>
			<cac:TaxCategory>
				<cbc:ID schemeID="UN/ECE 5305" schemeName="Tax Category Identifier" schemeAgencyName="United Nations Economic Commission for Europe">O</cbc:ID>
				<cac:TaxScheme>
					<cbc:ID schemeID="UN/ECE 5153" schemeAgencyID="6">9998</cbc:ID>
					<cbc:Name>INA</cbc:Name>
					<cbc:TaxTypeCode>FRE</cbc:TaxTypeCode>
				</cac:TaxScheme>
			</cac:TaxCategory>
		</cac:TaxSubtotal>';
        }
        if ($cabecera["TOTAL_OTR_IMP"] > 0) {
            $xmlCPE = $xmlCPE .
                    '<cac:TaxSubtotal>
			<cbc:TaxableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_OTR_IMP"] . '</cbc:TaxableAmount>
			<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_OTR_IMP"] . '</cbc:TaxAmount>
			<cac:TaxCategory>
				<cbc:ID schemeID="UN/ECE 5305" schemeName="Tax Category Identifier" schemeAgencyName="United Nations Economic Commission for Europe">S</cbc:ID>
				<cac:TaxScheme>
					<cbc:ID schemeID="UN/ECE 5153" schemeAgencyID="6">9999</cbc:ID>
					<cbc:Name>OTR</cbc:Name>
					<cbc:TaxTypeCode>OTH</cbc:TaxTypeCode>
				</cac:TaxScheme>
			</cac:TaxCategory>
		</cac:TaxSubtotal>';
        }
        //TOTAL=GRAVADA+IGV+EXONERADA
        //NO ENTRA GRATUITA(INAFECTA) NI DESCUENTO
        //SUB_TOTAL=PRECIO(SIN IGV) * CANTIDAD
        $xmlCPE = $xmlCPE .
                '</cac:TaxTotal>
    <cac:LegalMonetaryTotal>
        <cbc:PayableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL"] . '</cbc:PayableAmount>
    </cac:LegalMonetaryTotal>';



    for ($i = 0; $i < count($detalle); $i++) {
		if($detalle[$i]["txtCOD_TIPO_OPERACION"]=="10"){
            $xmlCPE = $xmlCPE . '<cac:CreditNoteLine>
        <cbc:ID>' . $detalle[$i]["txtITEM"] . '</cbc:ID>
<cbc:CreditedQuantity unitCode="' . $detalle[$i]["txtUNIDAD_MEDIDA_DET"] . '">' . $detalle[$i]["txtCANTIDAD_DET"] . '</cbc:CreditedQuantity>
<cbc:LineExtensionAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIMPORTE_DET"] . '</cbc:LineExtensionAmount>
        <cac:PricingReference>
            <cac:AlternativeConditionPrice>
<cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
                <cbc:PriceTypeCode>' . $detalle[$i]["txtPRECIO_TIPO_CODIGO"] . '</cbc:PriceTypeCode>
            </cac:AlternativeConditionPrice>
        </cac:PricingReference>
        <cac:TaxTotal>
<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIGV"] . '</cbc:TaxAmount>
            <cac:TaxSubtotal>
<cbc:TaxableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIMPORTE_DET"] . '</cbc:TaxableAmount>
<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIGV"] . '</cbc:TaxAmount>
                <cac:TaxCategory>
                    <cbc:Percent>' . $cabecera["P100IGV"] . '</cbc:Percent>
<cbc:TaxExemptionReasonCode>' . $detalle[$i]["txtCOD_TIPO_OPERACION"] . '</cbc:TaxExemptionReasonCode>
                    <cac:TaxScheme>
                        <cbc:ID>1000</cbc:ID>
                        <cbc:Name>IGV</cbc:Name>
                        <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
                    </cac:TaxScheme>
                </cac:TaxCategory>
            </cac:TaxSubtotal>
        </cac:TaxTotal>
        <cac:Item>
<cbc:Description><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtDESCRIPCION_DET"])) ? $detalle[$i]["txtDESCRIPCION_DET"] : "") . ']]></cbc:Description>
            <cac:SellersItemIdentification>
                <cbc:ID><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtCODIGO_DET"])) ? $detalle[$i]["txtCODIGO_DET"] : "") . ']]></cbc:ID>
            </cac:SellersItemIdentification>
        </cac:Item>
        <cac:Price>
<cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
        </cac:Price>
    </cac:CreditNoteLine>';
      }
	  if($detalle[$i]["txtCOD_TIPO_OPERACION"]=="20"){
            $xmlCPE = $xmlCPE . '<cac:CreditNoteLine>
        <cbc:ID>' . $detalle[$i]["txtITEM"] . '</cbc:ID>
<cbc:CreditedQuantity unitCode="' . $detalle[$i]["txtUNIDAD_MEDIDA_DET"] . '">' . $detalle[$i]["txtCANTIDAD_DET"] . '</cbc:CreditedQuantity>
<cbc:LineExtensionAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIMPORTE_DET"] . '</cbc:LineExtensionAmount>
        <cac:PricingReference>
            <cac:AlternativeConditionPrice>
<cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
                <cbc:PriceTypeCode>' . $detalle[$i]["txtPRECIO_TIPO_CODIGO"] . '</cbc:PriceTypeCode>
            </cac:AlternativeConditionPrice>
        </cac:PricingReference>
        <cac:TaxTotal>
<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">0</cbc:TaxAmount>
            <cac:TaxSubtotal>
<cbc:TaxableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIMPORTE_DET"] . '</cbc:TaxableAmount>
<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">0</cbc:TaxAmount>
                <cac:TaxCategory>
                    <cbc:Percent>0</cbc:Percent>
<cbc:TaxExemptionReasonCode>' . $detalle[$i]["txtCOD_TIPO_OPERACION"] . '</cbc:TaxExemptionReasonCode>
                    <cac:TaxScheme>
                        <cbc:ID>9997</cbc:ID>
                        <cbc:Name>EXO</cbc:Name>
                        <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
                    </cac:TaxScheme>
                </cac:TaxCategory>
            </cac:TaxSubtotal>
        </cac:TaxTotal>
        <cac:Item>
<cbc:Description><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtDESCRIPCION_DET"])) ? $detalle[$i]["txtDESCRIPCION_DET"] : "") . ']]></cbc:Description>
            <cac:SellersItemIdentification>
                <cbc:ID><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtCODIGO_DET"])) ? $detalle[$i]["txtCODIGO_DET"] : "") . ']]></cbc:ID>
            </cac:SellersItemIdentification>
        </cac:Item>
        <cac:Price>
<cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
        </cac:Price>
    </cac:CreditNoteLine>';
      }
	   if($detalle[$i]["txtCOD_TIPO_OPERACION"]=="30"){
            $xmlCPE = $xmlCPE . '<cac:CreditNoteLine>
        <cbc:ID>' . $detalle[$i]["txtITEM"] . '</cbc:ID>
<cbc:CreditedQuantity unitCode="' . $detalle[$i]["txtUNIDAD_MEDIDA_DET"] . '">' . $detalle[$i]["txtCANTIDAD_DET"] . '</cbc:CreditedQuantity>
<cbc:LineExtensionAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIMPORTE_DET"] . '</cbc:LineExtensionAmount>
        <cac:PricingReference>
            <cac:AlternativeConditionPrice>
<cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
                <cbc:PriceTypeCode>01</cbc:PriceTypeCode>
            </cac:AlternativeConditionPrice>
        </cac:PricingReference>
        <cac:TaxTotal>
<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">0</cbc:TaxAmount>
            <cac:TaxSubtotal>
<cbc:TaxableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIMPORTE_DET"] . '</cbc:TaxableAmount>
<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">0</cbc:TaxAmount>
                <cac:TaxCategory>
                    <cbc:Percent>0</cbc:Percent>
<cbc:TaxExemptionReasonCode>' . $detalle[$i]["txtCOD_TIPO_OPERACION"] . '</cbc:TaxExemptionReasonCode>
                    <cac:TaxScheme>
                        <cbc:ID>9998</cbc:ID>
                        <cbc:Name>INA</cbc:Name>
                        <cbc:TaxTypeCode>FRE</cbc:TaxTypeCode>
                    </cac:TaxScheme>
                </cac:TaxCategory>
            </cac:TaxSubtotal>
        </cac:TaxTotal>
        <cac:Item>
<cbc:Description><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtDESCRIPCION_DET"])) ? $detalle[$i]["txtDESCRIPCION_DET"] : "") . ']]></cbc:Description>
            <cac:SellersItemIdentification>
                <cbc:ID><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtCODIGO_DET"])) ? $detalle[$i]["txtCODIGO_DET"] : "") . ']]></cbc:ID>
            </cac:SellersItemIdentification>
        </cac:Item>
        <cac:Price>
<cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
        </cac:Price>
    </cac:CreditNoteLine>';
      }
	   if($detalle[$i]["txtCOD_TIPO_OPERACION"]=="31"){
            $xmlCPE = $xmlCPE . '<cac:CreditNoteLine>
        <cbc:ID>' . $detalle[$i]["txtITEM"] . '</cbc:ID>
<cbc:CreditedQuantity unitCode="' . $detalle[$i]["txtUNIDAD_MEDIDA_DET"] . '">' . $detalle[$i]["txtCANTIDAD_DET"] . '</cbc:CreditedQuantity>
<cbc:LineExtensionAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIMPORTE_DET"] . '</cbc:LineExtensionAmount>
        <cac:PricingReference>
            <cac:AlternativeConditionPrice>
<cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
                <cbc:PriceTypeCode>02</cbc:PriceTypeCode>
            </cac:AlternativeConditionPrice>
        </cac:PricingReference>
        <cac:TaxTotal>
<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">0</cbc:TaxAmount>
            <cac:TaxSubtotal>
<cbc:TaxableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIMPORTE_DET"] . '</cbc:TaxableAmount>
<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">0</cbc:TaxAmount>
                <cac:TaxCategory>
                    <cbc:Percent>0</cbc:Percent>
<cbc:TaxExemptionReasonCode>' . $detalle[$i]["txtCOD_TIPO_OPERACION"] . '</cbc:TaxExemptionReasonCode>
                    <cac:TaxScheme>
                        <cbc:ID>9996</cbc:ID>
                        <cbc:Name>GRA</cbc:Name>
                        <cbc:TaxTypeCode>FRE</cbc:TaxTypeCode>
                    </cac:TaxScheme>
                </cac:TaxCategory>
            </cac:TaxSubtotal>
        </cac:TaxTotal>
        <cac:Item>
<cbc:Description><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtDESCRIPCION_DET"])) ? $detalle[$i]["txtDESCRIPCION_DET"] : "") . ']]></cbc:Description>
            <cac:SellersItemIdentification>
                <cbc:ID><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtCODIGO_DET"])) ? $detalle[$i]["txtCODIGO_DET"] : "") . ']]></cbc:ID>
            </cac:SellersItemIdentification>
        </cac:Item>
        <cac:Price>
<cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
        </cac:Price>
    </cac:CreditNoteLine>';
      }
    }

    $xmlCPE = $xmlCPE . '
</CreditNote>';
    $doc->loadXML($xmlCPE);
//    $doc->save(dirname(__FILE__) . '/' . $ruta . '.XML');

file_put_contents(dirname(__FILE__,200)."rutaDeXml.txt", $ruta.'.XML');
file_put_contents($ruta.'(sinFirma).XML',$xmlCPE);

$doc->loadXML($xmlCPE); //Acá se incrusta la firma digital

//oldU $doc->save(dirname(__FILE__) . '/' . $ruta . '.XML');
$doc->save($ruta . '.XML');
return 'XML CREADO';
    //return '1';
}
function cpeND($ruta,
 //===================
        $cabecera, $detalle) {
    $doc = new DOMDocument();
    $doc->formatOutput = FALSE;
    $doc->preserveWhiteSpace = TRUE;
    $doc->encoding = 'ISO-8859-1';
    $xmlCPE = '<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?><DebitNote xmlns="urn:oasis:names:specification:ubl:schema:xsd:DebitNote-2" xmlns:cac="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2" xmlns:cbc="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2" xmlns:ccts="urn:un:unece:uncefact:documentation:2" xmlns:ds="http://www.w3.org/2000/09/xmldsig#" xmlns:ext="urn:oasis:names:specification:ubl:schema:xsd:CommonExtensionComponents-2" xmlns:qdt="urn:oasis:names:specification:ubl:schema:xsd:QualifiedDatatypes-2" xmlns:sac="urn:sunat:names:specification:ubl:peru:schema:xsd:SunatAggregateComponents-1" xmlns:udt="urn:un:unece:uncefact:data:specification:UnqualifiedDataTypesSchemaModule:2" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<ext:UBLExtensions>
<ext:UBLExtension>
<ext:ExtensionContent>
<sac:AdditionalInformation>
<sac:AdditionalMonetaryTotal>
<cbc:ID>1001</cbc:ID>
<cbc:PayableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_GRAVADAS"] . '</cbc:PayableAmount>
</sac:AdditionalMonetaryTotal>
</sac:AdditionalInformation>
</ext:ExtensionContent>
</ext:UBLExtension>
<ext:UBLExtension>
<ext:ExtensionContent>
</ext:ExtensionContent>
</ext:UBLExtension>
</ext:UBLExtensions>
<cbc:UBLVersionID>2.0</cbc:UBLVersionID>
<cbc:CustomizationID>1.0</cbc:CustomizationID>
<cbc:ID>' . $cabecera["NRO_COMPROBANTE"] . '</cbc:ID>
<cbc:IssueDate>' . $cabecera["FECHA_DOCUMENTO"] . '</cbc:IssueDate>
<cbc:DocumentCurrencyCode>' . $cabecera["COD_MONEDA"] . '</cbc:DocumentCurrencyCode>
<cac:DiscrepancyResponse>
    <cbc:ReferenceID>' . $cabecera["NRO_DOCUMENTO_MODIFICA"] . '</cbc:ReferenceID>
    <cbc:ResponseCode>' . $cabecera["COD_TIPO_MOTIVO"] . '</cbc:ResponseCode>
    <cbc:Description><![CDATA[' . $cabecera["DESCRIPCION_MOTIVO"] . ']]></cbc:Description>
</cac:DiscrepancyResponse>
<cac:BillingReference>
    <cac:InvoiceDocumentReference>
        <cbc:ID>' . $cabecera["NRO_DOCUMENTO_MODIFICA"] . '</cbc:ID>
        <cbc:DocumentTypeCode>' . $cabecera["TIPO_COMPROBANTE_MODIFICA"] . '</cbc:DocumentTypeCode>
    </cac:InvoiceDocumentReference>
</cac:BillingReference>
<cac:Signature>
    <cbc:ID>' . $cabecera["NRO_COMPROBANTE"] . '</cbc:ID>
    <cac:SignatoryParty>
        <cac:PartyIdentification>
            <cbc:ID>' . $cabecera["NRO_DOCUMENTO_EMPRESA"] . '</cbc:ID>
        </cac:PartyIdentification>
        <cac:PartyName>
            <cbc:Name><![CDATA[' . $cabecera["RAZON_SOCIAL_EMPRESA"] . ']]></cbc:Name>
        </cac:PartyName>
    </cac:SignatoryParty>
    <cac:DigitalSignatureAttachment>
        <cac:ExternalReference>
            <cbc:URI>#' . $cabecera["NRO_COMPROBANTE"] . '</cbc:URI>
        </cac:ExternalReference>
    </cac:DigitalSignatureAttachment>
</cac:Signature>
<cac:AccountingSupplierParty>
<cbc:CustomerAssignedAccountID>' . $cabecera["NRO_DOCUMENTO_EMPRESA"] . '</cbc:CustomerAssignedAccountID>
    <cbc:AdditionalAccountID>' . $cabecera["TIPO_DOCUMENTO_EMPRESA"] . '</cbc:AdditionalAccountID>
    <cac:Party>
        <cac:PartyName>
            <cbc:Name><![CDATA[' . $cabecera["NOMBRE_COMERCIAL_EMPRESA"] . ']]></cbc:Name>
        </cac:PartyName>
        <cac:PostalAddress>
            <cbc:ID>' . $cabecera["CODIGO_UBIGEO_EMPRESA"] . '</cbc:ID>
            <cbc:StreetName><![CDATA[' . $cabecera["DIRECCION_EMPRESA"] . ']]></cbc:StreetName>
            <cbc:CitySubdivisionName/>
            <cbc:CityName><![CDATA[' . $cabecera["DEPARTAMENTO_EMPRESA"] . ']]></cbc:CityName>
            <cbc:CountrySubentity><![CDATA[' . $cabecera["PROVINCIA_EMPRESA"] . ']]></cbc:CountrySubentity>
            <cbc:District><![CDATA[' . $cabecera["DISTRITO_EMPRESA"] . ']]></cbc:District>
            <cac:Country>
                <cbc:IdentificationCode>' . $cabecera["CODIGO_PAIS_EMPRESA"] . '</cbc:IdentificationCode>
            </cac:Country>
        </cac:PostalAddress>
        <cac:PartyLegalEntity>
            <cbc:RegistrationName><![CDATA[' . $cabecera["RAZON_SOCIAL_EMPRESA"] . ']]></cbc:RegistrationName>
        </cac:PartyLegalEntity>
    </cac:Party>
</cac:AccountingSupplierParty>
<cac:AccountingCustomerParty>
    <cbc:CustomerAssignedAccountID>' . $cabecera["NRO_DOCUMENTO_CLIENTE"] . '</cbc:CustomerAssignedAccountID>
    <cbc:AdditionalAccountID>' . $cabecera["TIPO_DOCUMENTO_CLIENTE"] . '</cbc:AdditionalAccountID>
    <cac:Party>
        <cac:PhysicalLocation>
            <cbc:Description><![CDATA[' . $cabecera["DIRECCION_CLIENTE"] . ']]></cbc:Description>
        </cac:PhysicalLocation>
        <cac:PartyLegalEntity>
            <cbc:RegistrationName><![CDATA[' . $cabecera["RAZON_SOCIAL_CLIENTE"] . ']]></cbc:RegistrationName>
            <cac:RegistrationAddress>
                <cbc:StreetName><![CDATA[' . $cabecera["CIUDAD_CLIENTE"] . ']]></cbc:StreetName>
                <cac:Country>
                    <cbc:IdentificationCode>' . $cabecera["COD_PAIS_CLIENTE"] . '</cbc:IdentificationCode>
                </cac:Country>
            </cac:RegistrationAddress>
        </cac:PartyLegalEntity>
    </cac:Party>
</cac:AccountingCustomerParty>
<cac:TaxTotal>
    <cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_IGV"] . '</cbc:TaxAmount>
    <cac:TaxSubtotal>
        <cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL_IGV"] . '</cbc:TaxAmount>
        <cac:TaxCategory>
            <cac:TaxScheme>
                <cbc:ID>1000</cbc:ID>
                <cbc:Name>IGV</cbc:Name>
                <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
            </cac:TaxScheme>
        </cac:TaxCategory>
    </cac:TaxSubtotal>
</cac:TaxTotal>
<cac:RequestedMonetaryTotal>
   <cbc:PayableAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $cabecera["TOTAL"] . '</cbc:PayableAmount>
</cac:RequestedMonetaryTotal>';

    for ($i = 0; $i < count($detalle); $i++) {
        $xmlCPE = $xmlCPE . '<cac:DebitNoteLine>
<cbc:ID>' . $detalle[$i]["txtITEM"] . '</cbc:ID>
<cbc:DebitedQuantity unitCode="' . $detalle[$i]["txtUNIDAD_MEDIDA_DET"] . '">' . $detalle[$i]["txtCANTIDAD_DET"] . '</cbc:DebitedQuantity>
<cbc:LineExtensionAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIMPORTE_DET"] . '</cbc:LineExtensionAmount>
<cac:PricingReference>
<cac:AlternativeConditionPrice>
<cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
<cbc:PriceTypeCode>' . $detalle[$i]["txtPRECIO_TIPO_CODIGO"] . '</cbc:PriceTypeCode>
</cac:AlternativeConditionPrice>
</cac:PricingReference>
<cac:TaxTotal>
<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIGV"] . '</cbc:TaxAmount>
<cac:TaxSubtotal>
<cbc:TaxAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtIGV"] . '</cbc:TaxAmount>
<cac:TaxCategory>
<cbc:TaxExemptionReasonCode>' . $detalle[$i]["txtCOD_TIPO_OPERACION"] . '</cbc:TaxExemptionReasonCode>
<cac:TaxScheme>
<cbc:ID>1000</cbc:ID>
<cbc:Name>IGV</cbc:Name>
<cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
</cac:TaxScheme>
</cac:TaxCategory>
</cac:TaxSubtotal>
</cac:TaxTotal>
<cac:Item>
<cbc:Description><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtDESCRIPCION_DET"]))?$detalle[$i]["txtDESCRIPCION_DET"]:"") . ']]></cbc:Description>
<cac:SellersItemIdentification>
<cbc:ID><![CDATA[' . ValidarCaracteresInv((isset($detalle[$i]["txtCODIGO_DET"]))?$detalle[$i]["txtCODIGO_DET"]:"") . ']]></cbc:ID>
</cac:SellersItemIdentification>
</cac:Item>
<cac:Price>
<cbc:PriceAmount currencyID="' . $cabecera["COD_MONEDA"] . '">' . $detalle[$i]["txtPRECIO_DET"] . '</cbc:PriceAmount>
</cac:Price>
</cac:DebitNoteLine>';
    }
    $xmlCPE = $xmlCPE . '</DebitNote>';

    $doc->loadXML($xmlCPE);
    $doc->save(dirname(__FILE__) . '/' . $ruta . '.XML');

    return 'XML CREADO';
}

function cpeBajaSunat($ruta,$cabecera, $detalle) {
    $doc = new DOMDocument();
    $doc->formatOutput = FALSE;
    $doc->preserveWhiteSpace = TRUE;
    $doc->encoding = 'ISO-8859-1';
    $xmlCPE = '<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?><VoidedDocuments xmlns="urn:sunat:names:specification:ubl:peru:schema:xsd:VoidedDocuments-1" xmlns:cac="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2" xmlns:cbc="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2" xmlns:ds="http://www.w3.org/2000/09/xmldsig#" xmlns:ext="urn:oasis:names:specification:ubl:schema:xsd:CommonExtensionComponents-2" xmlns:sac="urn:sunat:names:specification:ubl:peru:schema:xsd:SunatAggregateComponents-1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<ext:UBLExtensions>
<ext:UBLExtension>
<ext:ExtensionContent>
</ext:ExtensionContent>
</ext:UBLExtension>
</ext:UBLExtensions>
<cbc:UBLVersionID>2.0</cbc:UBLVersionID>
<cbc:CustomizationID>1.0</cbc:CustomizationID>
<cbc:ID>'.$cabecera["CODIGO"].'-'.$cabecera["SERIE"].'-'.$cabecera["SECUENCIA"].'</cbc:ID>
<cbc:ReferenceDate>'.$cabecera["FECHA_REFERENCIA"].'</cbc:ReferenceDate>
<cbc:IssueDate>'.$cabecera["FECHA_BAJA"].'</cbc:IssueDate>
<cac:Signature>
<cbc:ID>IDSignKG</cbc:ID>
<cac:SignatoryParty>
<cac:PartyIdentification>
<cbc:ID>'.$cabecera["NRO_DOCUMENTO_EMPRESA"].'</cbc:ID>
</cac:PartyIdentification>
<cac:PartyName>
<cbc:Name>'.ValidarCaracteresInv($cabecera["RAZON_SOCIAL"]).'</cbc:Name>
</cac:PartyName>
</cac:SignatoryParty>
<cac:DigitalSignatureAttachment>
<cac:ExternalReference>
<cbc:URI>#'.$cabecera["SERIE"].'-'.$cabecera["SECUENCIA"].'</cbc:URI>
</cac:ExternalReference>
</cac:DigitalSignatureAttachment>
</cac:Signature>
<cac:AccountingSupplierParty>
<cbc:CustomerAssignedAccountID>'.$cabecera["NRO_DOCUMENTO_EMPRESA"].'</cbc:CustomerAssignedAccountID>
<cbc:AdditionalAccountID>'.$cabecera["TIPO_DOCUMENTO"].'</cbc:AdditionalAccountID>
<cac:Party>
<cac:PartyLegalEntity>
<cbc:RegistrationName><![CDATA['.ValidarCaracteresInv($cabecera["RAZON_SOCIAL"]).']]></cbc:RegistrationName>
</cac:PartyLegalEntity>
</cac:Party>
</cac:AccountingSupplierParty>';

for ($i = 0; $i < count($detalle); $i++) {
$xmlCPE = $xmlCPE . '<sac:VoidedDocumentsLine>
<cbc:LineID>'.$detalle[$i]["ITEM"].'</cbc:LineID>
<cbc:DocumentTypeCode>'.$detalle[$i]["TIPO_COMPROBANTE"].'</cbc:DocumentTypeCode>
<sac:DocumentSerialID>'.$detalle[$i]["SERIE"].'</sac:DocumentSerialID>
<sac:DocumentNumberID>'.$detalle[$i]["NUMERO"].'</sac:DocumentNumberID>
<sac:VoidReasonDescription><![CDATA['.ValidarCaracteresInv($detalle[$i]["DESCRIPCION"]).']]></sac:VoidReasonDescription>
</sac:VoidedDocumentsLine>';
}
$xmlCPE = $xmlCPE . '</VoidedDocuments>';

$doc->loadXML($xmlCPE);
$doc->save($ruta.'.XML');
//$doc->save(dirname(__FILE__) . '/' . $ruta . '.XML');

return 'XML BAJA CREADO';
}



function cpeResumenBoleta($ruta,$cabecera, $detalle){
    $doc = new DOMDocument();
    $doc->formatOutput = FALSE;
    $doc->preserveWhiteSpace = TRUE;
    $doc->encoding = 'ISO-8859-1';
    $xmlCPE = '<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>
    <SummaryDocuments 
	xmlns="urn:sunat:names:specification:ubl:peru:schema:xsd:SummaryDocuments-1" 
	xmlns:cac="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2" 
	xmlns:cbc="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2" 
	xmlns:ds="http://www.w3.org/2000/09/xmldsig#" 
	xmlns:ext="urn:oasis:names:specification:ubl:schema:xsd:CommonExtensionComponents-2" 
	xmlns:sac="urn:sunat:names:specification:ubl:peru:schema:xsd:SunatAggregateComponents-1"
	xmlns:qdt="urn:oasis:names:specification:ubl:schema:xsd:QualifiedDatatypes-2" 
	xmlns:udt="urn:un:unece:uncefact:data:specification:UnqualifiedDataTypesSchemaModule:2">
	<ext:UBLExtensions>
		<ext:UBLExtension>
                        <ext:ExtensionContent>
			</ext:ExtensionContent>
		</ext:UBLExtension>
	</ext:UBLExtensions>
	<cbc:UBLVersionID>2.0</cbc:UBLVersionID>
	<cbc:CustomizationID>1.1</cbc:CustomizationID>
	<cbc:ID>' . $cabecera["CODIGO"] . '-' . $cabecera["SERIE"] . '-' . $cabecera["SECUENCIA"] . '</cbc:ID>
	<cbc:ReferenceDate>' . $cabecera["FECHA_REFERENCIA"] . '</cbc:ReferenceDate>
	<cbc:IssueDate>' . $cabecera["FECHA_DOCUMENTO"] . '</cbc:IssueDate>
	<cac:Signature>
		<cbc:ID>' . $cabecera["CODIGO"] . '-' . $cabecera["SERIE"] . '-' . $cabecera["SECUENCIA"] . '</cbc:ID>
		<cac:SignatoryParty>
			<cac:PartyIdentification>
				<cbc:ID>' . $cabecera["NRO_DOCUMENTO_EMPRESA"] . '</cbc:ID>
			</cac:PartyIdentification>
			<cac:PartyName>
				<cbc:Name>' . $cabecera["RAZON_SOCIAL"] . '</cbc:Name>
			</cac:PartyName>
		</cac:SignatoryParty>
		<cac:DigitalSignatureAttachment>
			<cac:ExternalReference>
				<cbc:URI>' . $cabecera["CODIGO"] . '-' . $cabecera["SERIE"] . '-' . $cabecera["SECUENCIA"] . '</cbc:URI>
			</cac:ExternalReference>
		</cac:DigitalSignatureAttachment>
	</cac:Signature>
	<cac:AccountingSupplierParty>
		<cbc:CustomerAssignedAccountID>' . $cabecera["NRO_DOCUMENTO_EMPRESA"] . '</cbc:CustomerAssignedAccountID>
		<cbc:AdditionalAccountID>' . $cabecera["TIPO_DOCUMENTO"] . '</cbc:AdditionalAccountID>
		<cac:Party>
			<cac:PartyLegalEntity>
				<cbc:RegistrationName>' . $cabecera["RAZON_SOCIAL"] . '</cbc:RegistrationName>
			</cac:PartyLegalEntity>
		</cac:Party>
	</cac:AccountingSupplierParty>';

	for ($i = 0; $i < count($detalle); $i++) {
        $xmlCPE = $xmlCPE . '<sac:SummaryDocumentsLine>
		<cbc:LineID>' . $detalle[$i]["ITEM"] . '</cbc:LineID>
		<cbc:DocumentTypeCode>' . $detalle[$i]["TIPO_COMPROBANTE"] . '</cbc:DocumentTypeCode>
		<cbc:ID>' . $detalle[$i]["NRO_COMPROBANTE"] . '</cbc:ID>
		<cac:AccountingCustomerParty>
			<cbc:CustomerAssignedAccountID>' . $detalle[$i]["NRO_DOCUMENTO"] . '</cbc:CustomerAssignedAccountID>
			<cbc:AdditionalAccountID>' . $detalle[$i]["TIPO_DOCUMENTO"] . '</cbc:AdditionalAccountID>
		</cac:AccountingCustomerParty>';
                if ($detalle[$i]["TIPO_COMPROBANTE"]=="07"||$detalle[$i]["TIPO_COMPROBANTE"]=="08"){
		 $xmlCPE = $xmlCPE . '<cac:BillingReference>
			<cac:InvoiceDocumentReference>
				<cbc:ID>' . $detalle[$i]["NRO_COMPROBANTE_REF"] . '</cbc:ID>
				<cbc:DocumentTypeCode>' . $detalle[$i]["TIPO_COMPROBANTE_REF"] . '</cbc:DocumentTypeCode>
			</cac:InvoiceDocumentReference>
		</cac:BillingReference>';
                }
		$xmlCPE = $xmlCPE . '<cac:Status>
			<cbc:ConditionCode>' . $detalle[$i]["STATU"] . '</cbc:ConditionCode>
		</cac:Status>                
		<sac:TotalAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["TOTAL"] . '</sac:TotalAmount>
		
                <sac:BillingPayment>
			<cbc:PaidAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["GRAVADA"] . '</cbc:PaidAmount>
			<cbc:InstructionID>01</cbc:InstructionID>
		</sac:BillingPayment>';
                
                if ($detalle[$i]["EXONERADO"] > 0) {
                $xmlCPE = $xmlCPE . '<sac:BillingPayment>
			<cbc:PaidAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["EXONERADO"] . '</cbc:PaidAmount>
			<cbc:InstructionID>02</cbc:InstructionID>
		</sac:BillingPayment>';
                }
                
                if ($detalle[$i]["INAFECTO"] > 0) {
                $xmlCPE = $xmlCPE . '<sac:BillingPayment>
			<cbc:PaidAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["INAFECTO"] . '</cbc:PaidAmount>
			<cbc:InstructionID>03</cbc:InstructionID>
		</sac:BillingPayment>';
                }
                
                if ($detalle[$i]["EXPORTACION"] > 0) {
                $xmlCPE = $xmlCPE . '<sac:BillingPayment>
			<cbc:PaidAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["EXPORTACION"] . '</cbc:PaidAmount>
			<cbc:InstructionID>04</cbc:InstructionID>
		</sac:BillingPayment>';
                }
                
                if ($detalle[$i]["GRATUITAS"] > 0) {
                $xmlCPE = $xmlCPE . '<sac:BillingPayment>
			<cbc:PaidAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["GRATUITAS"] . '</cbc:PaidAmount>
			<cbc:InstructionID>04</cbc:InstructionID>
		</sac:BillingPayment>';
                }
                
                if ($detalle[$i]["MONTO_CARGO_X_ASIG"] > 0) {
                    $xmlCPE = $xmlCPE . '<cac:AllowanceCharge>';
                    if ($detalle[$i]["CARGO_X_ASIGNACION"] == 1) {
                        $xmlCPE = $xmlCPE . '<cbc:ChargeIndicator>true</cbc:ChargeIndicator>';
                    }else{
                        $xmlCPE = $xmlCPE . '<cbc:ChargeIndicator>false</cbc:ChargeIndicator>';
                    }
                    $xmlCPE = $xmlCPE . '<cbc:Amount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["MONTO_CARGO_X_ASIG"] . '</cbc:Amount>
                    </cac:AllowanceCharge>';
                }
                if($detalle[$i]["ISC"]>0){
		$xmlCPE = $xmlCPE . '<cac:TaxTotal>
			<cbc:TaxAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["ISC"] . '</cbc:TaxAmount>
			<cac:TaxSubtotal>
				<cbc:TaxAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["ISC"] . '</cbc:TaxAmount>
				<cac:TaxCategory>
					<cac:TaxScheme>
						<cbc:ID>2000</cbc:ID>
						<cbc:Name>ISC</cbc:Name>
						<cbc:TaxTypeCode>EXC</cbc:TaxTypeCode>
					</cac:TaxScheme>
				</cac:TaxCategory>
			</cac:TaxSubtotal>
		</cac:TaxTotal>';
                }
                $xmlCPE = $xmlCPE . '<cac:TaxTotal>
			<cbc:TaxAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["IGV"] . '</cbc:TaxAmount>
			<cac:TaxSubtotal>
				<cbc:TaxAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["IGV"] . '</cbc:TaxAmount>
				<cac:TaxCategory>
					<cac:TaxScheme>
						<cbc:ID>1000</cbc:ID>
						<cbc:Name>IGV</cbc:Name>
						<cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
					</cac:TaxScheme>
				</cac:TaxCategory>
			</cac:TaxSubtotal>
		</cac:TaxTotal>';
                
                if($detalle[$i]["OTROS"]>0){
                $xmlCPE = $xmlCPE . '<cac:TaxTotal>
			<cbc:TaxAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["OTROS"] . '</cbc:TaxAmount>
			<cac:TaxSubtotal>
				<cbc:TaxAmount currencyID="' . $detalle[$i]["COD_MONEDA"] . '">' . $detalle[$i]["OTROS"] . '</cbc:TaxAmount>
				<cac:TaxCategory>
					<cac:TaxScheme>
						<cbc:ID>9999</cbc:ID>
						<cbc:Name>OTROS</cbc:Name>
						<cbc:TaxTypeCode>OTH</cbc:TaxTypeCode>
					</cac:TaxScheme>
				</cac:TaxCategory>
			</cac:TaxSubtotal>
		</cac:TaxTotal>';
                }
	$xmlCPE = $xmlCPE . '</sac:SummaryDocumentsLine>';
    }
    $xmlCPE = $xmlCPE . '</SummaryDocuments>';
    file_put_contents(dirname(__FILE__,200)."delBol.txt",$xmlCPE);
    $doc->loadXML($xmlCPE);
    $doc->save($ruta.'.XML');
    $doc->save(dirname(__FILE__,200)."bajaBol.XML");
    //$doc->save(dirname(__FILE__) . '/' . $ruta . '.XML');

    return 'XML RESUMEN BOLETA CREADO';
}

function cpeFacturaPrueba($ruta) {
    $doc = new DOMDocument();
    $doc->formatOutput = FALSE;
    $doc->preserveWhiteSpace = TRUE;
    $doc->encoding = 'ISO-8859-1';
    $xmlCPE = '<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?>
                <Invoice xmlns="urn:oasis:names:specification:ubl:schema:xsd:Invoice-2" xmlns:cac="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2" xmlns:cbc="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2" xmlns:ccts="urn:un:unece:uncefact:documentation:2" xmlns:ds="http://www.w3.org/2000/09/xmldsig#" xmlns:ext="urn:oasis:names:specification:ubl:schema:xsd:CommonExtensionComponents-2" xmlns:qdt="urn:oasis:names:specification:ubl:schema:xsd:QualifiedDatatypes-2" xmlns:sac="urn:sunat:names:specification:ubl:peru:schema:xsd:SunatAggregateComponents-1" xmlns:schemaLocation="urn:oasis:names:specification:ubl:schema:xsd:Invoice-2" xmlns:udt="urn:un:unece:uncefact:data:specification:UnqualifiedDataTypesSchemaModule:2" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
                <ext:UBLExtensions>
                <ext:UBLExtension>
                <ext:ExtensionContent>
                <sac:AdditionalInformation>
                <sac:AdditionalMonetaryTotal>
                <cbc:ID>1001</cbc:ID>
                <cbc:PayableAmount currencyID="PEN">625.0</cbc:PayableAmount>
                </sac:AdditionalMonetaryTotal>
                <sac:AdditionalMonetaryTotal>
                <cbc:ID>1002</cbc:ID>
                <cbc:PayableAmount currencyID="PEN">0.0</cbc:PayableAmount>
                </sac:AdditionalMonetaryTotal>
                <sac:AdditionalMonetaryTotal>
                <cbc:ID>1003</cbc:ID>
                <cbc:PayableAmount currencyID="PEN">0.0</cbc:PayableAmount>
                </sac:AdditionalMonetaryTotal>
                <sac:AdditionalMonetaryTotal>
                <cbc:ID>1004</cbc:ID>
                <cbc:PayableAmount currencyID="PEN">0.0</cbc:PayableAmount>
                </sac:AdditionalMonetaryTotal>
                <sac:AdditionalProperty>
                <cbc:ID>1000</cbc:ID>
                <cbc:Value>SETECIENTOS TREINTA Y SIETE CON 50/100 SOLES</cbc:Value>
                </sac:AdditionalProperty>
                </sac:AdditionalInformation>
                </ext:ExtensionContent>
                </ext:UBLExtension>
                <ext:UBLExtension>
                <ext:ExtensionContent>
                </ext:ExtensionContent>
                </ext:UBLExtension>
                </ext:UBLExtensions>
                <cbc:UBLVersionID>2.0</cbc:UBLVersionID>
                <cbc:CustomizationID>1.0</cbc:CustomizationID>
                <cbc:ID>F001-5079</cbc:ID>
                <cbc:IssueDate>2017-05-10</cbc:IssueDate>
                <cbc:InvoiceTypeCode>01</cbc:InvoiceTypeCode>
                <cbc:DocumentCurrencyCode>PEN</cbc:DocumentCurrencyCode>
                <cac:Signature>
                <cbc:ID>F001-5079</cbc:ID>
                <cac:SignatoryParty>
                <cac:PartyIdentification>
                <cbc:ID>10447915125</cbc:ID>
                </cac:PartyIdentification>
                <cac:PartyName>
                <cbc:Name><![CDATA[JOSE LUI ZAMBRANO YACHA]]></cbc:Name>
                </cac:PartyName>
                </cac:SignatoryParty>
                <cac:DigitalSignatureAttachment>
                <cac:ExternalReference>
                <cbc:URI>#F001-5079</cbc:URI>
                </cac:ExternalReference>
                </cac:DigitalSignatureAttachment>
                </cac:Signature>
                <cac:AccountingSupplierParty>
                <cbc:CustomerAssignedAccountID>10447915125</cbc:CustomerAssignedAccountID>
                <cbc:AdditionalAccountID>6</cbc:AdditionalAccountID>
                <cac:Party>
                <cac:PartyName>
                <cbc:Name><![CDATA[JOSE LUI ZAMBRANO YACHA]]></cbc:Name>
                </cac:PartyName>
                <cac:PostalAddress>
                <cbc:ID>070104</cbc:ID>
                <cbc:StreetName><![CDATA[PSJ HUAMPANI]]></cbc:StreetName>
                <cbc:CitySubdivisionName/>
                <cbc:CityName><![CDATA[LIMA]]></cbc:CityName>
                <cbc:CountrySubentity><![CDATA[LIMA]]></cbc:CountrySubentity>
                <cbc:District><![CDATA[CHACLACAYO]]></cbc:District>
                <cac:Country>
                <cbc:IdentificationCode>PE</cbc:IdentificationCode>
                </cac:Country>
                </cac:PostalAddress>
                <cac:PartyLegalEntity>
                <cbc:RegistrationName><![CDATA[JOSE LUI ZAMBRANO YACHA]]></cbc:RegistrationName>
                </cac:PartyLegalEntity>
                </cac:Party>
                </cac:AccountingSupplierParty>
                <cac:AccountingCustomerParty>
                <cbc:CustomerAssignedAccountID>10447915125</cbc:CustomerAssignedAccountID>
                <cbc:AdditionalAccountID>6</cbc:AdditionalAccountID>
                <cac:Party>
                <cac:PhysicalLocation>
                <cbc:Description><![CDATA[HUAMPANI ALTO ZON 1 MZ B LT 6]]></cbc:Description>
                </cac:PhysicalLocation>
                <cac:PartyLegalEntity>
                <cbc:RegistrationName><![CDATA[JOSE LUIS ZAMBRANO YACHA]]></cbc:RegistrationName>
                <cac:RegistrationAddress>
                <cbc:StreetName><![CDATA[LIMA]]></cbc:StreetName>
                <cac:Country>
                <cbc:IdentificationCode>PE</cbc:IdentificationCode>
                </cac:Country>
                </cac:RegistrationAddress>
                </cac:PartyLegalEntity>
                </cac:Party>
                </cac:AccountingCustomerParty>
                <cac:TaxTotal>
                <cbc:TaxAmount currencyID="PEN">112.5</cbc:TaxAmount>
                <cac:TaxSubtotal>
                <cbc:TaxAmount currencyID="PEN">112.5</cbc:TaxAmount>
                <cac:TaxCategory>
                <cac:TaxScheme>
                <cbc:ID>1000</cbc:ID>
                <cbc:Name>IGV</cbc:Name>
                <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
                </cac:TaxScheme>
                </cac:TaxCategory>
                </cac:TaxSubtotal>
                </cac:TaxTotal>
                <cac:LegalMonetaryTotal>
                <cbc:LineExtensionAmount currencyID="PEN">625.0</cbc:LineExtensionAmount>
                <cbc:TaxExclusiveAmount currencyID="PEN">112.5</cbc:TaxExclusiveAmount>
                <cbc:PayableAmount currencyID="PEN">737.5</cbc:PayableAmount>
                </cac:LegalMonetaryTotal>
                <cac:InvoiceLine>
                <cbc:ID>1</cbc:ID>
                <cbc:InvoicedQuantity unitCode="NIU">1.00001</cbc:InvoicedQuantity>
                <cbc:LineExtensionAmount currencyID="PEN">625.0</cbc:LineExtensionAmount>
                <cac:PricingReference>
                <cac:AlternativeConditionPrice>
                <cbc:PriceAmount currencyID="PEN">737.5</cbc:PriceAmount>
                <cbc:PriceTypeCode>01</cbc:PriceTypeCode>
                </cac:AlternativeConditionPrice>
                </cac:PricingReference>
                <cac:TaxTotal>
                <cbc:TaxAmount currencyID="PEN">112.5</cbc:TaxAmount>
                <cac:TaxSubtotal>
                <cbc:TaxAmount currencyID="PEN">112.5</cbc:TaxAmount>
                <cac:TaxCategory>
                <cbc:TaxExemptionReasonCode>10</cbc:TaxExemptionReasonCode>
                <cac:TaxScheme>
                <cbc:ID>1000</cbc:ID>
                <cbc:Name>IGV</cbc:Name>
                <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
                </cac:TaxScheme>
                </cac:TaxCategory>
                </cac:TaxSubtotal>
                </cac:TaxTotal>
                <cac:Item>
                <cbc:Description><![CDATA[PRUEBA]]></cbc:Description>
                <cac:SellersItemIdentification>
                <cbc:ID><![CDATA[0001]]></cbc:ID>
                </cac:SellersItemIdentification>
                </cac:Item>
                <cac:Price>
                <cbc:PriceAmount currencyID="PEN">625.0</cbc:PriceAmount>
                </cac:Price>
                </cac:InvoiceLine>
                </Invoice>
            ';

    $doc->loadXML($xmlCPE);
    $doc->save(dirname(__FILE__) . '/' . $ruta . '.XML');

    return '1';
}


function cpeFactura_2_1_err($ruta,$cab, $det){
$doc = new DOMDocument();
$doc->formatOutput = FALSE;
$doc->preserveWhiteSpace = TRUE;
$doc->encoding = 'ISO-8859-1';

$xmlCPE = '<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?>
<Invoice xmlns="urn:oasis:names:specification:ubl:schema:xsd:Invoice-2"
         xmlns:cac="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2"
         xmlns:cbc="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2"
         xmlns:ccts="urn:un:unece:uncefact:documentation:2"
         xmlns:ds="http://www.w3.org/2000/09/xmldsig#"
         xmlns:ext="urn:oasis:names:specification:ubl:schema:xsd:CommonExtensionComponents-2"
         xmlns:qdt="urn:oasis:names:specification:ubl:schema:xsd:QualifiedDatatypes-2"
         xmlns:sac="urn:sunat:names:specification:ubl:peru:schema:xsd:SunatAggregateComponents-1"
         xmlns:schemaLocation="urn:oasis:names:specification:ubl:schema:xsd:Invoice-2"
         xmlns:udt="urn:un:unece:uncefact:data:specification:UnqualifiedDataTypesSchemaModule:2"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <ext:UBLExtensions>
      <ext:UBLExtension>
         <ext:ExtensionContent />
      </ext:UBLExtension>
  </ext:UBLExtensions>
  <cbc:UBLVersionID>2.1</cbc:UBLVersionID>
  <cbc:CustomizationID>2.0</cbc:CustomizationID>
  <cbc:ID>' .                   $cab["NRO_COMPROBANTE"].'</cbc:ID>
  <cbc:IssueDate>' .            $cab["FECHA_DOCUMENTO"].'</cbc:IssueDate>
  <cbc:IssueTime>' .            $cab["HORA_DOCUMENTO"] .  '</cbc:IssueTime>
  <cbc:DueDate>'.               $cab["FVENCE_DOCUMENTO"]. '</cbc:DueDate>
  <cbc:InvoiceTypeCode listID="0101"
         listAgencyName="PE:SUNAT"
         listName="SUNAT:Identificador de Tipo de Documento"
         listURI="urn:pe:gob:sunat:cpe:see:gem:catalogos:catalogo01">'
        .$cab["COD_TIPO_DOCUMENTO"].'</cbc:InvoiceTypeCode>';
if($cab["TOTAL_LETRAS"]<>""){
$xmlCPE = $xmlCPE.
'<cbc:Note languageLocaleID="1000"><![CDATA['.$cab["TOTAL_LETRAS"].']]></cbc:Note>';
}
$xmlCPE.='
  <cbc:DocumentCurrencyCode listID="ISO 4217 Alpha"
              listName="Currency"
              listAgencyName="United Nations Economic Commission for Europe">'.$cab["COD_MONEDA"].'
  </cbc:DocumentCurrencyCode>
  <cbc:LineCountNumeric>'.$cab["LineCountNumeric"].'</cbc:LineCountNumeric>
  <cac:Signature>
      <cbc:ID>' .               $cab["NRO_COMPROBANTE"].'</cbc:ID>
      <cac:SignatoryParty>
          <cac:PartyIdentification>
              <cbc:ID>' .       $cab["NRO_DOCUMENTO_EMPRESA"].'</cbc:ID>
          </cac:PartyIdentification>
          <cac:PartyName>
              <cbc:Name><![CDATA['.$cab["RAZON_SOCIAL_EMPRESA"].']]></cbc:Name>
          </cac:PartyName>
      </cac:SignatoryParty>
      <cac:DigitalSignatureAttachment>
          <cac:ExternalReference>
              <cbc:URI>#'.$cab["NRO_COMPROBANTE"].'</cbc:URI>
          </cac:ExternalReference>
      </cac:DigitalSignatureAttachment>
  </cac:Signature>
  <cac:AccountingSupplierParty>
    <cac:Party>
      <cac:PartyIdentification>';
$xmlCPE.='<cbc:ID schemeID="'.$cab["TIPO_DOCUMENTO_EMPRESA"].'">'.$cab["NRO_DOCUMENTO_EMPRESA"].'</cbc:ID>';
        //<cbc:ID schemeID="'.$cab["TIPO_DOCUMENTO_EMPRESA"].'"
        //        schemeName="SUNAT:Identificador de Documento de Identidad"
        //        schemeAgencyName="PE:SUNAT"
        //        schemeURI="urn:pe:gob:sunat:cpe:see:gem:catalogos:catalogo06">'.$cab["NRO_DOCUMENTO_EMPRESA"].'</cbc:ID>
$xmlCPE.='
      </cac:PartyIdentification>
      <cac:PartyName>
        <cbc:Name><![CDATA['.$cab["NOMBRE_COMERCIAL_EMPRESA"].']]></cbc:Name>
      </cac:PartyName>
      <cac:PartyLegalEntity>
        <cbc:RegistrationName><![CDATA['.$cab["NOMBRE_COMERCIAL_EMPRESA"].']]></cbc:RegistrationName>
        <cac:RegistrationAddress>
          <cbc:ID>'.$cab["CODIGO_UBIGEO_EMPRESA"].'</cbc:ID>
          <cbc:AddressTypeCode>0000</cbc:AddressTypeCode>
        </cac:RegistrationAddress>
      </cac:PartyLegalEntity>
    </cac:Party>
  </cac:AccountingSupplierParty>
  <cac:AccountingCustomerParty>
      <cac:Party>
         <cac:PartyIdentification>
             <cbc:ID schemeID="'.$cab["TIPO_DOCUMENTO_CLIENTE"].'">'.$cab["NRO_DOCUMENTO_CLIENTE"].'</cbc:ID>
         </cac:PartyIdentification>
         <cac:PartyLegalEntity>
            <cbc:RegistrationName><![CDATA['.$cab["RAZON_SOCIAL_CLIENTE"].']]></cbc:RegistrationName>
            <cac:RegistrationAddress>
               <cac:AddressLine>
                  <cbc:Line><![CDATA['.$cab["DIRECCION_CLIENTE"].']]></cbc:Line>
               </cac:AddressLine>
               <cac:Country>
                  <cbc:IdentificationCode>'.$cab["COD_PAIS_CLIENTE"].'</cbc:IdentificationCode>
               </cac:Country>
            </cac:RegistrationAddress>
         </cac:PartyLegalEntity>
      </cac:Party>
  </cac:AccountingCustomerParty>
  <cac:TaxTotal>
      <cbc:TaxAmount currencyID="'.$cab["COD_MONEDA"].'">'.$cab["TOTAL_IGV"].'</cbc:TaxAmount>
      <cac:TaxSubtotal>
          <cbc:TaxableAmount currencyID="'.$cab["COD_MONEDA"].'">'.$cab["SUB_TOTAL"].'</cbc:TaxableAmount>
          <cbc:TaxAmount currencyID="'.$cab["COD_MONEDA"].'">'.$cab["TOTAL_IGV"].'</cbc:TaxAmount>
          <cac:TaxCategory>
              <cac:TaxScheme>
                  <cbc:ID>1000</cbc:ID>
                  <cbc:Name>IGV</cbc:Name>
                  <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
              </cac:TaxScheme>
              </cac:TaxCategory>
      </cac:TaxSubtotal>
  </cac:TaxTotal>
  <cac:LegalMonetaryTotal>
      <cbc:LineExtensionAmount currencyID="'.$cab["COD_MONEDA"].'">'.$cab["SUB_TOTAL"].'</cbc:LineExtensionAmount>
      <cbc:PayableAmount currencyID="'      .$cab["COD_MONEDA"].'">'.$cab["TOTAL"].'</cbc:PayableAmount>
  </cac:LegalMonetaryTotal>';

for ($i = 0; $i < count($det); $i++) {
    $xmlCPE = $xmlCPE . '
    <cac:InvoiceLine>
      <cbc:ID>'.$det[$i]["txtITEM"].'</cbc:ID>
      <cbc:InvoicedQuantity unitCode="'.$det[$i]["txtUNIDAD_MEDIDA_DET"].'">'.$det[$i]["txtCANTIDAD_DET"].'</cbc:InvoicedQuantity>
      <cbc:LineExtensionAmount currencyID="'.$cab["COD_MONEDA"].'">'.$det[$i]["txtIMPORTE_DET"].'</cbc:LineExtensionAmount>
      <cac:PricingReference>
          <cac:AlternativeConditionPrice>
              <cbc:PriceAmount currencyID="'.$cab["COD_MONEDA"].'">'.$det[$i]["txtPRECIO_DET"].'</cbc:PriceAmount>
              <cbc:PriceTypeCode>'.$det[$i]["txtPRECIO_TIPO_CODIGO"].'</cbc:PriceTypeCode>
          </cac:AlternativeConditionPrice>
      </cac:PricingReference>
      <cac:TaxTotal>
          <cbc:TaxAmount currencyID="'.$cab["COD_MONEDA"].'">'
                                      .($det[$i]["txtCANTIDAD_DET"]*$det[$i]["txtPRECIO_DET"]-$det[$i]["txtIMPORTE_DET"]).'
          </cbc:TaxAmount>
          <cac:TaxSubtotal>
              <cbc:TaxableAmount currencyID="'.$cab["COD_MONEDA"].'">'.$det[$i]["txtIMPORTE_DET"].'</cbc:TaxableAmount>
              <cbc:TaxAmount currencyID="'.$cab["COD_MONEDA"].'">'
                                          .($det[$i]["txtCANTIDAD_DET"]*$det[$i]["txtPRECIO_DET"]-$det[$i]["txtIMPORTE_DET"]).'
              </cbc:TaxAmount>
              <cac:TaxCategory>
                  <cbc:Percent>'.$cab["P100IGV"].'</cbc:Percent>
                  <cbc:TaxExemptionReasonCode>'.$det[$i]["txtCOD_TIPO_OPERACION"].'</cbc:TaxExemptionReasonCode>
                  <cac:TaxScheme>
                      <cbc:ID>1000</cbc:ID>
                      <cbc:Name>IGV</cbc:Name>
                      <cbc:TaxTypeCode>VAT</cbc:TaxTypeCode>
                  </cac:TaxScheme>
              </cac:TaxCategory>
          </cac:TaxSubtotal>
      </cac:TaxTotal>
      <cac:Item>
          <cbc:Description><![CDATA[' . ValidarCaracteresInv((isset($det[$i]["txtDESCRIPCION_DET"]))?$det[$i]["txtDESCRIPCION_DET"]:"") . ']]></cbc:Description>
          <cac:SellersItemIdentification>
              <cbc:ID><![CDATA[' . ValidarCaracteresInv((isset($det[$i]["txtCODIGO_DET"]))?$det[$i]["txtCODIGO_DET"]:"") . ']]></cbc:ID>
          </cac:SellersItemIdentification>
      </cac:Item>
      <cac:Price>
          <cbc:PriceAmount currencyID="'.$cab["COD_MONEDA"].'">'.round($det[$i]["txtIMPORTE_DET"]/$det[$i]["txtCANTIDAD_DET"],2).'</cbc:PriceAmount>
      </cac:Price>
  </cac:InvoiceLine>';
}

$xmlCPE = $xmlCPE . '
</Invoice>';

file_put_contents(dirname(__FILE__,200)."dat(U).txt", $ruta . '.XML');
file_put_contents($ruta.'(sinFirma).XML',$xmlCPE);

$doc->loadXML($xmlCPE); //Acá se incrusta la firma digital

//oldU $doc->save(dirname(__FILE__) . '/' . $ruta . '.XML');
$doc->save($ruta . '.XML');
return 'XML CREADO';
//dfgdfgdfgdf
//fin function cpeFactura($ruta,$cab, $det)
}
?>
